#if PRINT_DEBUG
	#define log_DEBUG NSLog
	#define dump_RESPONDER_CHAIN __dump_responder_chain
	#define dump_VIEW_CHILDREN __dump_children_views
	#define dump_VIEW_PARENTS __dump_parent_views
	#define dump_ALL_FONTS __dump_all_fonts
#else
	#define log_DEBUG __do_nothing_func__
	#define dump_RESPONDER_CHAIN __do_nothing_func__
	#define dump_VIEW_CHILDREN __do_nothing_func__
	#define dump_VIEW_PARENTS __do_nothing_func__
	#define dump_ALL_FONTS __do_nothing_func__
#endif

#define PROTECTED_SECTION_START @try {
#define PROTECTED_SECTION_END } @catch (NSException* ex) { NSLog (@"exception:%@", ex); }

void __dump_all_fonts ();
void __dump_responder_chain (id object);
void __dump_children_views (id view);
void __dump_children_views_x (id object, NSInteger level);
void __dump_parent_views (id object);

#define GEN_ASSIGN_PROPERTY(t,f,n)\
- (void) f:(t) val { __changing_start (self, @#n);n = val;__changing_end (self, @#n); };- (t) n { return n; }

#define GEN_RETAIN_PROPERTY(t,f,n)\
- (void) f:(t) val { __changing_start (self, @#n);[n release];n = [val retain];__changing_end (self, @#n); };- (t) n { return n; }

#define GEN_SHARED_INSTANCE(t)\
static t* __ ## t ## _shared = nil; + (t*) sharedInstance { if (__ ## t ## _shared != nil) { return __ ## t ## _shared; } else { __ ## t ## _shared = [[t alloc]init];return __ ## t ## _shared;} };

#define SET_SHARED_INSTANCE(t,v)\
__ ## t ## _shared = v;

BOOL is_url (NSString* str);
NSURL* u(id str, ...);

#define c(str) [NSCharacterSet characterSetWithCharactersInString:str]
#define s(a...) [NSString stringWithFormat:a]
#define b(x) [NSNumber numberWithBool:x]
#define i(x) [NSNumber numberWithInt:x]
#define l(x) [NSNumber numberWithLong:x]

#define bval(x,k) [[x valueForKey:k]boolValue]
#define ival(x,k) [[x valueForKey:k]intValue]
#define lval(x,k) [[x valueForKey:k]longValue]
#define sval(x,k) [[x valueForKey:k]stringValue]

#define array(a...) [NSMutableArray arrayWithObjects:a]
#define dict(a...) [NSMutableDictionary dictionaryWithObjectsAndKeys:a]

#define MYConfig [NSUserDefaults standardUserDefaults]

#define UIApp [UIApplication sharedApplication]

void __do_nothing_func__ (NSString *str, ...);
id __get_first_responder (id object);

#define foreachGetEnumerator(c) \
([c respondsToSelector:@selector(objectEnumerator)] ? \
 [c objectEnumerator] : \
 c)
#define foreachGetIMP(e) \
[foreachEnum methodForSelector:@selector(nextObject)]
#define foreachCallIMP(imp, e) \
((IMP)imp)(e, @selector(nextObject))
#define foreachGetFirst(imp, e) \
(e ? foreachCallIMP(imp, e) : nil)
#define foreach(object, collection) \
for ( id foreachCollection = collection, \
			foreachEnum = foreachGetEnumerator(foreachCollection), \
			foreachIMP = (id)foreachGetIMP(foreachEnum), \
			object = foreachGetFirst(foreachIMP, foreachEnum); \
			object; \
			object = foreachCallIMP(foreachIMP, foreachEnum) )
#define foreacht(type, object, collection) \
for ( type foreachCollection = (id)collection, \
			*foreachEnum = (id)foreachGetEnumerator((id)foreachCollection), \
			*foreachIMP = (id)foreachGetIMP((id)foreachEnum), \
			*object = foreachGetFirst(foreachIMP, foreachEnum); \
			object; \
			object = foreachCallIMP(foreachIMP, foreachEnum) )

#define eq isEqualToString:
#define ne isNotEqualToString:
#define eqi isEqualToStringIgnoringCase:

id v(id a, id b);

NSString* nonEmptyString (NSString* str);
BOOL str_isNullOrEmpty (NSString* str);
BOOL str_isNotNullOrEmpty (NSString* str);
BOOL list_isNotNullOrEmpty (NSArray* list);
BOOL list_isNullOrEmpty (NSArray* list);

void list_insert_before (NSMutableArray* ls, NSArray* objects, id before);
void list_insert_after (NSMutableArray* ls, NSArray* objects, id after);

void run_idle_loop ();
void sleep_main_loop (NSTimeInterval lt);

void clear_all_notifications (id object);
NSString* mk_uuid ();
NSString* document_directory ();

void send_event (id object, NSString* evt, id arg, ...);
void post_event (id object, NSString* evt, id arg, ...);
void enqueue_event (id object, NSString* evt, id arg, ...);
void bind_event (id src, NSString* evt, id dst, SEL sel);
void unbind_event (id src, NSString* evt, id dst);

id eval_func (id object, SEL func, id arg, ...);
id eval_func_chain (id object, SEL func, id arg, ...);
void eval_func_after (NSTimeInterval time, id object, SEL func, id arg, ...);
void eval_func_every (NSTimeInterval time, id object, SEL func, id arg, ...);

void eval_single_func_after (NSTimeInterval time, id object, SEL func, id arg, ...);
id first_responder ();

NSString* path_dirname (NSString* path);
NSString* path_basename_noext (NSString *path);
NSString* path_basename_ext (NSString *path);
NSString* path_basename (NSString *path);

id get_appctx (NSString* name);
void set_appctx (NSString* name, id val);

static NSMutableArray* __NotificationProxyObjects = nil;
#pragma unused(__NotificationProxyObjects)

@interface __NotificationProxy : NSObject {
	BOOL asyncmode;
	id destination;
	id event;
	SEL selector;
	NSTimer* timer;
	NSInvocation* invocation;
}
- (id) initForEvent:(NSString*) evt withDestination:(id)dest andSelector:(SEL) sel;  
- (id) initForEvent:(NSString*) evt withDestination:(id)dest andTimeInterval:(NSTimeInterval) tm andInvocation:(NSInvocation*) inv;
- (void) handleNotification:(NSNotification*)evt;
@end

void dump_responder_chain (id object);

int __changing_start (id ob, NSString *nm);
int __changing_end (id ob, NSString *nm);

BOOL write_plist (NSString* fl, id object);
id read_plist (NSString* fl);

id load_object (NSString* name, id parent);
NSString* resource_path (NSString* name);

BOOL rename_selector (Class _class, SEL _oldSelector, SEL _newSelector);

NSString* mk_partition_key(NSString* str);

#define CHANGE_PROPERTY(c) for (int i = __changing_start(self, @#c);i < 1;__changing_end(self, @#c),i++)
#define RETAIN_PROPERTY(c, v) do{id vv=v;if(c!=vv){[vv retain];[c release];c=vv;}}while(0);
#define CLEAR_PROPERTY(c) [c release];c = nil;

NSDate* shift_date (NSDate* d, NSInteger v, char type);
NSString* format_date (NSDate* dt, NSString* fmt);
NSString* todays_date (NSString* fmt);
NSDate*   string_to_date (NSString* dt, NSString* fmt);
NSString* mk_unique_name (NSString* name, NSArray* ls);

#if TARGET_OS_IPHONE

@interface __MYDisplayAlertDelegate : NSObject {
	NSInteger button;
}
@end

#endif

//RGB color macro UIColorFromRGB(0xCECECE);
#define UIColorFromRGB(rgbValue) [UIColor \
colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 \
green:((float)((rgbValue & 0xFF00) >> 8))/255.0 \
blue:((float)(rgbValue & 0xFF))/255.0 alpha:1.0]
 
//RGB color macro with alpha
#define UIColorFromRGBWithAlpha(rgbValue,a) [UIColor \
colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 \
green:((float)((rgbValue & 0xFF00) >> 8))/255.0 \
blue:((float)(rgbValue & 0xFF))/255.0 alpha:a]

#define MINUTES(x) x*60
#define HOURS(x) x*60*60
#define DAYS(x) x*60*60*24
#define WEEKS(x) x*60*60*24*7

NSInteger MYDisplayAlert (NSString* msg);
NSInteger MYDisplayError (NSError* msg);
BOOL MYDisplayQuestion (NSString* msg, NSString* yes, NSString* no);
